using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized ;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ComboBox
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Location = new System.Drawing.Point(32, 32);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(472, 312);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 374);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			

			this.gridControl1.CellModels.Add("MyRadioButton", new MyRadioButtonCellModel(this.gridControl1.Model));

			StringCollection sc = new StringCollection();
			sc.AddRange(new String[]{	"button 0", 
										"button 1/disabled", 
										"button 2", 
										"button 3"});
			
				
			this.gridControl1[2, 2].ChoiceList = sc;
			this.gridControl1[2, 2].CellType = "MyRadioButton";
			this.gridControl1[2, 2].CellValue = 0;//selected button
			this.gridControl1[2, 2].TextAlign = GridTextAlign.Right ;//where descriptions are
			this.gridControl1[2, 2].TextMargins.Left = 5;
			this.gridControl1[2, 2].TextMargins.Right = 5;



			sc = new StringCollection();
			sc.AddRange(new string[]{"item1","item2"});

			this.gridControl1[4, 4].ChoiceList = sc;
			this.gridControl1[4,4].CellType = "MyRadioButton";
			this.gridControl1[4, 4].CellValue = 1;//selected button
			this.gridControl1[4, 4].TextAlign = GridTextAlign.Left ;//where descriptions are


			this.gridControl1.RowHeights[2] = 110;
			this.gridControl1.RowHeights[4] =50;  
			
			
		}

		private void gridControl1_CurrentCellValidateString(object sender, GridCurrentCellValidateStringEventArgs e)
		{
			
		}
	}

	public class MyRadioButtonCellModel : GridRadioButtonCellModel
	{
		public MyRadioButtonCellModel(GridModel grid)
			: base(grid)
		{
		 
		}

		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new MyRadioButtonCellRenderer(control, this);
		}
	}

	public class MyRadioButtonCellRenderer : GridRadioButtonCellRenderer
	{
		public MyRadioButtonCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
			: base(grid, cellModel)
		{
			this.SupportsFocusControl = false; 
		}
	
		protected override System.Drawing.Rectangle OnLayout(int rowIndex, int colIndex, Syncfusion.Windows.Forms.Grid.GridStyleInfo style, System.Drawing.Rectangle innerBounds, System.Drawing.Rectangle[] buttonsBounds)

		{

			Rectangle clientRectangle = GridMargins.RemoveMargins(innerBounds, style.TextMargins.ToMargins());

			StringCollection buttonInfos = style.ChoiceList;


			int count = buttonInfos != null ? buttonInfos.Count : 0;

			if (buttonInfos != null && count > 0)

			{

				int width = clientRectangle.Width ;
				int height = clientRectangle.Height/count;
				if (height == 0)
					height = clientRectangle.Height;
				GridVerticalAlignment verticalAlign = style.VerticalAlignment;
				int yOffset = clientRectangle.Top;
				if (verticalAlign == GridVerticalAlignment.Middle)
					yOffset += (clientRectangle.Height - height)/2;
				else if (verticalAlign == GridVerticalAlignment.Bottom)
					yOffset += (clientRectangle.Height - height);
				int xOffset = clientRectangle.Left;
				for (int n = 0; n < count; n++)
				{
					Rectangle bounds = new Rectangle(xOffset, yOffset, width, height);
					buttonsBounds[n] = bounds;
					if(buttonInfos != null)
					{
						((GridRadioButton)GetButton(n)).Enabled = this.GetButtonInfo(n, style).Enabled;
					}
					yOffset += height;
				}
			}
			clientRectangle.Width = 0;
			return clientRectangle;
		}
		private GridRadioButtonInfo GetButtonInfo(int buttonNumber, GridStyleInfo style)
		{
			StringCollection sc = style.ChoiceList as StringCollection;
			if (sc != null)
			{
				string des = sc[buttonNumber];
				bool disabled = des.ToLower().EndsWith("/disabled");
				if(disabled)
					des = des.Substring(0, des.Length - 9);
				return new GridRadioButtonInfo(des, !disabled);
			}
			return null;

		}

	}
}
